<?php
//if uninstall not called from WordPress exit
use MailOptin\Core\Core;

if (!defined('WP_UNINSTALL_PLUGIN')) {
    exit();
}

// Load MailOptin file
include_once('mailoptin.php');

$remove_plugin_data = \MailOptin\Core\PluginSettings\Settings::instance()->remove_plugin_data();

if ($remove_plugin_data == 'true') {

    /** Delete plugin options */
    delete_option(MAILOPTIN_CONNECTIONS_DB_OPTION_NAME);
    delete_option(MAILOPTIN_SETTINGS_DB_OPTION_NAME);
    delete_option(MO_OPTIN_CAMPAIGN_WP_OPTION_NAME);
    delete_option(MO_OPTIN_TEMPLATE_WP_OPTION_NAME);

    delete_option('mo_install_date');
    delete_option('mo_plugin_activated');
    delete_option('mo_license_status');
    delete_option('mo_license_key');
    // do not remove mo_license_once_active option
    // delete_option('mo_license_once_active');

    global $wpdb;
    $db_prefix = $wpdb->prefix;

    $drop_tables = array();

    $drop_tables[] = "DROP TABLE IF EXISTS {$db_prefix}" . Core::optin_campaign_meta_table_name;
    $drop_tables[] = "DROP TABLE IF EXISTS {$db_prefix}" . Core::campaign_log_meta_table_name;
    $drop_tables[] = "DROP TABLE IF EXISTS {$db_prefix}" . Core::campaign_log_table_name;
    $drop_tables[] = "DROP TABLE IF EXISTS {$db_prefix}" . Core::optin_campaigns_table_name;
    $drop_tables[] = "DROP TABLE IF EXISTS {$db_prefix}" . Core::conversions_table_name;
    $drop_tables[] = "DROP TABLE IF EXISTS {$db_prefix}" . Core::email_campaigns_table_name;

    $drop_tables = apply_filters('mo_drop_database_tables', $drop_tables, $db_prefix);

    foreach ($drop_tables as $tables) {
        $wpdb->query($tables);
    }
}