<?php

namespace MailOptin\AweberConnect;

class Subscription extends AbstractAweberConnect
{
    protected $email;
    protected $name;
    protected $list_id;
    protected $extras;

    public function __construct($email, $name, $list_id, $extras)
    {
        $this->email = $email;
        $this->name = $name;
        $this->list_id = $list_id;
        $this->extras = $extras;

        parent::__construct();
    }

    /**
     * @return mixed
     */
    public function subscribe()
    {
        try {
            $response = $this->aweber_instance()->addSubscriberEmailAndName(
                $this->account_id,
                $this->list_id,
                $this->email,
                $this->name
            );

            if ($response) {
                return parent::ajax_success();
            }

            return parent::ajax_failure(__('There was an error adding the contact to Aweber. Please try again.', 'mailoptin'));

        } catch (\Exception $e) {
            self::save_optin_error_log($e->getCode() . ': ' . $e->getMessage(), 'aweber');
            return parent::ajax_failure(__('There was an error adding the contact to Aweber. Please try again.', 'mailoptin'));
        }
    }
}