<?php

namespace MailOptin\CampaignMonitorConnect;

class Subscription extends AbstractCampaignMonitorConnect
{
    protected $email;
    protected $name;
    protected $list_id;

    public function __construct($email, $name, $list_id)
    {
        $this->email = $email;
        $this->name = $name;
        $this->list_id = $list_id;

        parent::__construct();
    }

    /**
     * @return mixed
     */
    public function subscribe()
    {
        try {

            $response = $this->campaignmonitorInstance()->addSubscriberEmailName($this->list_id, $this->email, $this->name);

            if ($response) {
                return parent::ajax_success();
            }

            return parent::ajax_failure(__('There was an error adding the contact to Campaign Monitor. Please try again.', 'mailoptin'));

        } catch (\Exception $e) {
            self::save_optin_error_log($e->getCode() . ': ' . $e->getMessage(), 'campaignmonitor');
            return parent::ajax_failure(__('There was an error adding the contact to Campaign Monitor. Please try again.', 'mailoptin'));
        }
    }
}