<?php

namespace MailOptin\CtctConnect;

class Subscription extends AbstractCtctConnect
{
    protected $email;
    protected $name;
    protected $list_id;

    public function __construct($email, $name, $list_id)
    {
        $this->email = $email;
        $this->name = $name;
        $this->list_id = $list_id;

        parent::__construct();
    }

    /**
     * @return mixed
     */
    public function subscribe()
    {
        try {
            $name_split = self::get_first_last_names($this->name);

            $response = $this->ctctInstance()->addContactToList($this->email, $this->list_id, $name_split[0], $name_split[1]);

            if ($response) {
                return parent::ajax_success();
            }

            return parent::ajax_failure(__('There was an error adding the contact to Constant Contact. Please try again.', 'mailoptin'));

        } catch (\Exception $e) {
            self::save_optin_error_log($e->getCode() . ': ' . $e->getMessage(), 'constantcontact');
            return parent::ajax_failure(__('There was an error adding the contact to Constant Contact. Please try again.', 'mailoptin'));
        }
    }
}