<?php

namespace MailOptin\MailChimpConnect;

class ConnectSettingsPage
{
    public function __construct()
    {
        add_filter('mailoptin_connections_settings_page', array($this, 'connection_settings'), 10, 99);
    }

    public function connection_settings($arg)
    {
        $settingsArg[] = array(
            'section_title' => __('MailChimp Connection', 'mailoptin'),
            'mailchimp_api_key' => array(
                'type' => 'text',
                'label' => __('Enter API Key', 'mailoptin'),
                'description' => sprintf(
                    __('Log in to your %sMailChimp account%s to get your API Key.', 'mailoptin'),
                    '<a target="_blank" href="https://admin.mailchimp.com/account/api-key-popup">',
                    '</a>'
                ),
            )
        );

        return array_merge($arg, $settingsArg);
    }

    public static function get_instance()
    {
        static $instance = null;

        if (is_null($instance)) {
            $instance = new self();
        }

        return $instance;
    }
}