<?php

namespace MailOptin\SendyConnect;

use SendyPHP\SendyPHP;

class Subscription extends AbstractSendyConnect
{
    protected $email;
    protected $name;
    protected $list_id;

    public function __construct($email, $name, $list_id)
    {
        $this->email = $email;
        $this->name = $name;
        $this->list_id = $list_id;

        parent::__construct();
    }

    /**
     * @return array
     */
    public function subscribe()
    {
        $api_config = parent::api_config();

        $config = array(
            'api_key' => $api_config['api_key'],
            'installation_url' => $api_config['installation_url'],
            // this is redundant because it isn't used by create campaign. added to prevent any exception being thrown.
            'list_id' => $this->list_id
        );

        $sendy = new SendyPHP($config);

        $response = $sendy->subscribe(
            array(
                'name' => $this->name,
                'email' => $this->email
            )
        );

        // return true if $response['status'] is true otherwise false.
        if (isset($response['status']) && $response['status']) {
            return parent::ajax_success();
        }

        self::save_optin_error_log($response['message'], 'sendy');
        return parent::ajax_failure(__('There was an error adding the contact to Sendy. Please try again.', 'mailoptin'));
    }
}